Last Comment Bug 1214433 - (webext1.0) [tracking] First release of Web Extensions
(webext1.0)
: [tracking] First release of Web Extensions
Status: RESOLVED FIXED
triaged
:
Product: Toolkit
Classification: Components
Component: WebExtensions: Untriaged (show other bugs)
: unspecified
: All All
-- normal with 19 votes (vote)
: ---
Assigned To: Nobody; OK to take it and work on it
:
: Andy McKay [:andym]
Mentors:
Depends on: webext-port-avira 1185459 webext-android webext-oop 1197420 1207597 1208775 webext-webnav webRequest-full webext-windows webext-port-noscript 1267027 719905 1156826 1185460 1190663 1190677 1190685 1190688 1190689 1190690 1192432 1192433 1192435 1192437 1192439 1193837 1197346 1197422 1198405 1199050 1199052 1199056 1199253 1200146 1200674 1202734 1203233 1203330 1203738 1205886 1207394 1208257 1208761 webext-port-reddit-enhancement-suite 1208874 1209184 1210037 1210583 1210996 1211366 1211665 1213426 1213433 1213450 webext-tabs 1213632 1213895 1213975 1213993 1214007 1214040 1214658 1214790 1214952 1214955 1215130 1215197 1215375 1215893 1217879 1218175 1230447 1235005 1238585 1239109 1239822 1244474 1246748 1246749 1246754
Blocks:
  Show dependency treegraph
 
Reported: 2015-10-13 15:15 PDT by Andy McKay [:andym]
Modified: 2017-01-04 07:28 PST (History)
52 users (show)
amckay: blocking‑webextensions-
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---


Attachments

Description User image Andy McKay [:andym] 2015-10-13 15:15:33 PDT
Web Extensions are kind of there are already, but this tracks all the bugs we want to complete to get to a first release of Web Extensions.
Comment 1 User image Sergey Rozhenko 2016-03-30 10:04:35 PDT
Is this the death of FireFox? Let me rephrase it: will this make addons like "Classic Theme Restorer" impossible after XUL/XPCOM support is discontinued?
Comment 2 User image Stephan Sokolow 2016-03-30 10:15:43 PDT
(In reply to Sergey Rozhenko from comment #1)
> Is this the death of FireFox? Let me rephrase it: will this make addons like
> "Classic Theme Restorer" impossible after XUL/XPCOM support is discontinued?

Last I heard, the plan was to replace traditional XUL/XPCOM with a mechanism where a WebExtensions addon could depend on a more manually-reviewed "native.js" module which adds new APIs to what the WebExtensions environment can see.

(The idea being that, over time, these "native.js" modules would get refined and then merged in as new official APIs.)
Comment 3 User image Sergey Rozhenko 2016-03-30 10:55:07 PDT
(In reply to Stephan Sokolow from comment #2)

Ah, good then. I was worried we could lose the full customizability of FF, which is its core feature.
Comment 4 User image Andy McKay [:andym] 2016-06-07 08:32:52 PDT
This was tracking stuff we wanted to do for 48. That version of Firefox has been and going. Sadly we didn't get everything on this list (there was a lot), but we got a lot of stuff done. We haven't really been using this tracking bug anymore, rather using the blocking-webextensions flag.

For that reason, I'm going to close this bug.
Comment 5 User image Mitth'raw'nuruodo 2017-01-03 15:44:48 PST
(In reply to Sergey Rozhenko from comment #3)
> (In reply to Stephan Sokolow from comment #2)
> 
> Ah, good then. I was worried we could lose the full customizability of FF,
> which is its core feature.

Indeed, that will happen, because the relevant bug was WONTFIXed on the grounds that native.js is incompatible with Mozilla's vision for Firefox.
Comment 6 User image Stephan Sokolow 2017-01-03 16:04:38 PST
(In reply to Mitth'raw'nuruodo from comment #5)
> (In reply to Sergey Rozhenko from comment #3)
> > (In reply to Stephan Sokolow from comment #2)
> > 
> > Ah, good then. I was worried we could lose the full customizability of FF,
> > which is its core feature.
> 
> Indeed, that will happen, because the relevant bug was WONTFIXed on the
> grounds that native.js is incompatible with Mozilla's vision for Firefox.

*nod* Given that Firefox has no --enable-easy-off-store-extension-install equivalent to allow a secondary ecosystem to develop, as has occurred for YouTube downloaders on Chrome, that makes a XUL-less AMO even less free than Chrome's ecosystem. (Not even counting Firefox not yet having support for APIs like chrome.downloads.onDeterminingFilename)

As soon as that change was announced, I started making plans to ride the trains down from Aurora through ESR and then switch to something like Seamonkey or Pale Moon. (Or even Chrome, given that Chrome at least has an actual menu behind the hamburger button rather than the "toolbar buttons in a panel" touchscreen/toy interface I'll be forced onto if Classic Theme Restorer dies out.)

At the moment, given that I've finally lost faith in Mozilla and don't have high hopes for anyone else developing an acceptable ecosystem, I'm working to find/write browser-agnostic solutions for as much as possible of what I currently rely on extensions for (eg. adding a new root into the CA store and setting up an HTTPS-capable proxy to reinvent conveniences like InlineDisposition as well as my privacy and security extensions) in a way that'll work with any browser.

...and, of course, I've prioritized my efforts to write an external bookmark manager with an interface capable of scaling to the volume and complexity I need. (I already use an external password manager, so that's not an issue.)
Comment 7 User image Stephan Sokolow 2017-01-04 07:28:14 PST
...though I suppose another potential option would be if something like Qt's QWebEngine gained built-in support for loading WebExtensions.

Then this push toward the lowest common denominator would mean it'd be feasible for me to maintain my own homegrown browser frontend on top of Blink+WebExtensions. (Actually, to be honest, that'd be even more appealing than if Firefox hadn't started retiring XUL.)

Note You need to log in before you can comment on or make changes to this bug.